#!/usr/bin/perl
#
# This program comes with ABSOLUTELY NO WARRANTY.
# This is free software, and you are welcome to redistribute it
# under certain conditions. See docs/GPL.txt for details.
#
# written by mjm ( www.codito.de ) and snakebyte ( www.kryptocrew.de/snakebyte/ )
#
use Getopt::Std;

# load our plugins
use mod::ftp;			# FTP
use mod::smtp;			# SMTP
use mod::pop;			# POP
use mod::http;			# HTTP
use mod::irc;			# IRC
#use mod::dummy; 

use Socket;
my $SOCKET = "";

# stringsizes we test during overflow testing
# the hope is to overwrite a return pointer, making the server execute invalid code and crash
my @overflowstrings = ("A" x 254, "A" x 255, "A" x 1023, "A" x 1024, "A" x 2047, "A" x 2048, "A" x 5000);

# strings for format string testing...
# the hope is that we reach an invalid pointer on the stack so the server segfaults and coredumps
my @formatstrings = ("%s" x 8, "%s" x 15, "%s" x 30, "%s" x 200, "%.1024d", "%.2048d", "%.4096d");

print ("\n BED 0.3 by mjm ( www.codito.de ) & eric ( www.kryptocrew.de/snakebyte/ )\n\n");

# get the parameters we need for every test
getopts('s:t:p:u:v:w:x:');
&usage unless(defined $opt_s);

$opt_s = lc($opt_s); # convert it to lowercase, so it's easier for us to test for it

# check the options which are special for the different modules
if ($opt_s eq "ftp"){			#FTP
  $module = new mod::ftp;
} elsif ( $opt_s eq "smtp"){		#SMTP
  $module = new mod::smtp;
} elsif ( $opt_s eq "pop") {		#POP
  $module = new mod::pop;
} elsif ( $opt_s eq "http") {           #HTTP
  $module = new mod::http;
} elsif ( $opt_s eq "irc") {		# IRC
  $module = new mod::irc;
# } elsif ($opt_s eq "dummy") {		# dummy module
# $module = new mod::dummy;
} else {				#False service
  print "Invalid service selected\n"; &usage;
}

%special_cfg=(
  "t" => "$opt_t",		# target
  "p" => "$opt_p",		# port

  "u" => "$opt_u",		# special parameters for each plugin..
  "v" => "$opt_v",
  "w" => "$opt_w",
  "x" => "$opt_x"
);
$module->init(%special_cfg);

# test stuff that might happen during login
print ("* Login tests\n");
@cmdArray = $module->getLoginarray;	# which login stuff do we test
if ( @cmdArray ne "" ){
	print ("Buffer overflow testing:\n");
	&testThis(@overflowstrings);
	print ("Formatstring testing:\n");
	&testThis(@formatstrings);
}

# test the stuff that might happen during normal protocol events
print ("* Normal tests\n");
@cmdArray = $module->getCommandarray;	# which commands do we test
@login = $module->getLogin;
print ("Buffer overflow testing:\n");
&testThis(@overflowstrings);
print ("Formatstring testing:\n");
&testThis(@formatstrings);

# make the module test all other stuff
print ("Other tests:\n");
$module->testMisc();
print ("All tests done.\n\n");
exit(0);

# this function tests each of the two arrays ( buffer overflow and format string )
sub testThis(){
	@testArray = @_;						# wheter we test format strings or buffer overflows
	$quit = $module->getQuit;
	foreach $cmd (@cmdArray){
		$cmd2 = $cmd;
		$cmd2 =~ s/\n/; /ig;		# remove \r and \n for nice displaying
		$cmd2 =~ s/\r/ /ig;
		print "\t\ttesting: $cmd2\n";

		foreach $LS (@testArray){
			sleep(2);		# some servers would kick us for too fast logins
			$command = $cmd;
			$command =~ s/XAXAX/$LS/ig;		# prepare the string
	   		$iaddr = inet_aton($module->{target})             || die "Unknown host: $module->{target}\n";
			$paddr = sockaddr_in($module->{port}, $iaddr)     || die "getprotobyname: $!\n";
			$proto = getprotobyname($module->{proto})                    || die "getprotobyname: $!\n";
			socket(SOCKET, PF_INET, SOCK_STREAM, $proto)      || die "socket: $!\n";
			connect(SOCKET, $paddr)				  || die "connection attempt failed: $!\n";

			# login ...
			foreach $log (@login){
				send(SOCKET, $log, 0);
			 	sleep(1);	# some daemons need some time to reply
			}

    		send(SOCKET, $command, 0);		# send the attack and verify that the server is still alive

		# Is there a possibility to check within connection?
		if ($module->{vrfy} ne "") {
    			send(SOCKET, $module->{vrfy},0) || die "Problem occured with $cmd\n";
				$recvbuf = <SOCKET>				|| die "Problem occured with $cmd\n";
				send(SOCKET, $quit, 0);			# close the connection
	       		close SOCKET;
		} else {
			close SOCKET;
                        $iaddr = inet_aton($module->{target})             || die "Unknown host: $module->{target}\n";
                        $paddr = sockaddr_in($module->{port}, $iaddr)     || die "getprotobyname: $!\n";
                        $proto = getprotobyname('tcp')                    || die "getprotobyname: $!\n";
                        socket(SOCKET, PF_INET, SOCK_STREAM, $proto)      || die "socket: $!\n";
                        connect(SOCKET, $paddr)				  || die "Problem occured with $cmd\n";
			close SOCKET;
		}
    	}
	}
}

# how to use these scripts...
sub usage {
print qq~
 Usage:

 $0 -s <plugin> -t <target> -p <port> [ depends on the plugin ]

 <plugin>   = FTP/SMTP/POP/HTTP/IRC
 <target>   = Host to check (default: localhost)
 <port>     = Port to connect to (default: standard port)

 use "$0 -s <plugin>" to obtain the parameters you need for the plugin.

~;
exit(1);
}
