package mod::dummy;
use Socket;

# Example plugin for bed2
#
# Feel free to fill in the gaps ... :)
#
# search bed.pl for "dummy" to see what you need to
# change to include your module ( just 2 lines, no need
# to be scared *g* )
#

# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# create a new instance of this object
sub new{
	my $this = {};

	# these ones must be defined
	$this->{proto}	      = undef;
	$this->{target}       = undef;
	$this->{port}         = undef;
	$this->{vrfy}	      = undef;

	# define everything else you might need
	$this->{dummy}         = undef;
	bless $this;
	return $this;
}

# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# initialise some parameters
sub init{
	my $this = shift;
	%special_cfg=@_;

    # Set protocol tcp/udp
    $this->{proto} = "tcp"; 

    # check for missing args, set target and host
    # every module has to do this
    if ($special_cfg{'t'} eq "") { $this->{target}='127.0.0.1'; }
      else { $this->{target} = $special_cfg{'t'}; }
    if ($special_cfg{'p'} eq "") { $this->{port}='110'; }
      else { $this->{port} = $special_cfg{'p'}; }

	# verify you got everything you need,
	# $special_cfg will provide you the commandline
	# switches from u, v, w and x
	if ( $special_cfg{'u'} eq "") {
		 print qq~
 	Parameters for the dummy plugin:

 		-u <description what the user should provide>

~;
		 exit(1);
	}

	# set info nessecairy for for your module..
	$this->{dummy} = $special_cfg{'u'};
	# how can bed check that the server is still alive
	# ( server should reply something to this )
	$this->{vrfy} = "HELP\r\n";
}

# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# how to quit ?
sub getQuit{
	return("QUIT\r\n");
}

# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# what to test without doing a login before
# ..mainly the login stuff *g*
sub getLoginarray {
 my $this = shift;
 @Loginarray = (
 	"USER XAXAX\r\n",
 	"USER $this->{username}\r\nPASS XAXAX\r\n"
 )
 return (@Loginarray);
}


# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# which commands does this protocol know ?
sub getCommandarray {
	my $this = shift;
	# the XAXAX will be replaced with the buffer overflow / format string
	# place every command in this array you want to test
	@cmdArray = (
		"foo XAXAX\r\n",
		"bar XAXAX\r\n",
		"XAXAX\r\n"
	);
	return(@cmdArray);
}


# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# what to send to login ?
sub getLogin{ 		# login procedure
	my $this = shift;
	@login = ("Hi, I am a dummy\r\n");
	return(@login);
}

# \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# here we can test everything besides buffer overflows and format strings
sub testMisc{
	my $this = shift;
	return();
}


1;
